"use strict";
/**
 * @author Kuitos
 * @homepage https://github.com/kuitos/
 * @since 2018-06-08 10:16
 */
Object.defineProperty(exports, "__esModule", { value: true });
var mobx_1 = require("mobx");
function collectData(vm, data) {
    var dataDefinition = typeof data === 'function' ? data.call(vm, vm) : (data || {});
    var filteredData = Object.keys(dataDefinition).reduce(function (result, field) {
        var value = dataDefinition[field];
        if (mobx_1.isObservable(value)) {
            Object.defineProperty(vm, field, {
                configurable: true,
                get: function () {
                    return value;
                },
                // @formatter:off
                // tslint:disable-next-line
                set: function () { }
                // @formatter:on
            });
        }
        else {
            result[field] = value;
        }
        return result;
    }, {});
    return filteredData;
}
exports.default = collectData;
//# sourceMappingURL=collectData.js.map